DBT <- function(x,z,a=0){
#>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#>>>>                                                 <<<<<
#>>>>   Estimation by Bradley-Terry Model with Draw   <<<<<
#>>>>                                                 <<<<<
#>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      m <- sqrt(length(x))
      y <- t(x)
      n <- x + y + z
      pi <- oldpi <- rep(50,m)
      t <- pi1 <- newpi1 <- rep(0,m)
      count2 <- zsum <- nsum <- 0
      P <- Q <- matrix(0,m,m)
      k <- sum(pi)
      for(i in 1:m){
         t[i] <- sum(x[i,])
         zsum <- zsum + sum(z[i,])
         nsum <- nsum + sum(n[i,])
      }
      if (a==0) A <- zsum/nsum
      else A <- a
      B <- -0.05
      repeat{
         count1 <- 0
         repeat{
            for(i in 1:m){
               for(j in 1:m){
                  P[i,j] <- (pi[i] + pi[j])^2
                  Q[i,j] <- (pi[i] - pi[j])^2
               }
            }
            s1 <- s2 <- rep(0,m)
            for(i in 1:m){
               for(j in 1:m){
                  if(j != i){
                    s1[i] <- s1[i] + ((n[i,j] - z[i,j])/(pi[i] + pi[j]))
                    s2[i] <- s2[i] + ((4 * B * pi[j] * (pi[i] - pi[j]))/(pi[i]+pi[j])) *
                              (((A * n[i,j] - z[i,j]) * P[i,j]) - (B * n[i,j] * Q[i,j])) /
                              ((((1 - A) * P[i,j]) + (B * Q[i,j])) * ((A * P[i,j]) - (B * Q[i,j])))
                  }
               }
            }
            for(i in 1:m)
               pi1[i] <- t[i]/(s1[i] - s2[i])
            pi1sum <- sum(pi1)
            for(i in 1:m){
               newpi1[i] <- (k * pi1[i])/pi1sum
               if(newpi1[i] < 0)
                 newpi1[i] <- 0.1
            }
            d1 <- 0
            for(i in 1:m)
               d1 <- d1 + (((pi[i] - newpi1[i])/50)^2)
            if(sqrt(d1) < 1e-08)
              break
            count1 <- count1 + 1
            for(i in 1:m)
               pi[i] <- newpi1[i]
            if(count1 >= 10)
              break
         }
         if(count2 >= 2000)
           break
         s3 <- s4 <- s5 <- s6 <- s7 <- s8 <- 0
         for(i in 1:m){
            for(j in 1:m){
               if(i < j){
                 s3 <- s3 + z[i,j]
                 s4 <- s4 + (((n[i,j] - z[i,j]) * Q[i,j])/
                        (((1 - A) * P[i,j]) + (B * Q[i,j])))
                 s5 <- s5 + n[i,j]
               }
            }
         }
         A1 <- (s3 + B * s4)/s5
         for(i in 1:m){
            for(j in 1:m){
               if(i < j){
                 s6 <- s6 + (A * n[i,j] - z[i,j])
                 s7 <- s7 + ((z[i,j] * Q[i,j])/((A * P[i,j])
                        - (B * Q[i,j])))
               }
            }
         }
         B1 <- s6/s7
         if(A1 < 0)
           A1 <- 0.00001
         else if(A1 > 1)
           A1 <- 0.99999
         for(i in 1:m)
            s8 <- s8 + ((pi[i] - oldpi[i])/50)^2
         d2 <- (A - A1)^2 + (B - B1)^2 + s8
         if(sqrt(d2) < 1e-06)
           break
         count2 <- count2 + 1
         A <- (A1 + (9 * A))/10
         B <- (B1 + (9 * B))/10
         for(i in 1:m)
            oldpi[i] <- pi[i]
      }
      list(Strength = pi,Alpha = A,Beta = B) #
#<<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>>
#
#  >>> input <<<
#           x: matrix of the number of wins
#              (i-th row team wins x_ij times to j-th column team).
#           z: matrix of the number of draws
#              (i-th row team draws x_ij times to j-th column team).
#           a: initial parameter of alpha (default: auto setting).
#
#  >>> output <<<
#    Strength: vector of PIs (TSUYOSA).
#       Alpha: draw parameter alpha (draw probability for same strength).
#        Beta: draw parameter beta (coef. of pi's difference).
#
#<<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>>
#                                         01/28/03  by imai
#                                         06/21/05  modified by matsu
}
