BH<-function(x, q = 0.05)
{
#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#>>>          The method of BH                             <<<
#>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  p<-sort(x)
  names(x)<-c(1:length(x))
  judge<-names(sort(x))
  bh<-test<-c(rep(1,each=length(x)))
  for(i in 1:length(x)){
    bh[i]<-(q*i)/length(x)
  }
  i<-length(x)
  while(p[i]>(q*i)/length(x) && i!=0){
    test[i]<-0
    i<-i-1
  }  
  if(i!=0){
    J<-NULL
    J<-append(J,judge[1:i])
  }
  p<-matrix(p,ncol=1)
  colnames(p)<-paste("p.value")
  bh<-matrix(bh,ncol=1)
  colnames(bh)<-paste("BH  ")
  test<-matrix(test,ncol=1)
  colnames(test)<-paste("test")
  result<-cbind(p,bh,test)
  if(i!=0){
    list(result=result,Significant_number =J ,q = q)
  }else{
    list(result=result,Significant_number=NULL ,q = q)
  }
#>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>
#  >>>input<<<
#       x: vector data (p-values)
#
#  >>>output<<<
#       result
#         p.value           : p-values (the ordered p-values)  
#         FDR value         : e.x. (0.005,EEE,0.05)
#         test              : test result (by the ordered x)
#                             (1: significant)
#                             (0: not significant)
#       Significant         : test result
#                             (rejected input data's hypotheses number)
#       q                   : e.x. (0.05)
#              
#>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<
#
#                                                         01/17/06  by  Horiuchi
}

ABH<-function(x, q = 0.05)
{
#>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#>>>          The method of ABH                             <<<
#>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  p<-sort(x)
  names(x)<-c(1:length(x))
  judge<-names(sort(x))
  S<-bh<-abh<-test1<-test2<-c(rep(1,each=length(x)))
  for(i in 1:length(x)){
    bh[i]<-(q*i)/length(x)
  }
  i<-length(x)
  while(p[i]>(q*i)/length(x) && i!=0){
    test1[i]<-0
    i<-i-1
  }
  if(i==0){
    test2<-test1<-c(rep(0,each=length(x)))
    abh[1:length(x)]<-0
  }else{
    for(i in 1:length(x)){
      S[i]<-(1-p[i])/(length(x)+1-i)
    }
    i<-2
    while(S[i]>=S[i-1]&&i<=length(x)){
      i<-i+1
    }
    if(length(x)<i){
      i<-length(x)
    }
    m_0<-min((1/S[i]+1),length(x))
    m_0<-as.integer(m_0)
    for(i in 1:length(x)){
      abh[i]<-(q*i)/m_0
    }
    i<-length(x)
    while(p[i]>(q*i)/m_0 && i!=0){
      test2[i]<-0
      i<-i-1
    }
    J<-NULL
    J<-append(J,judge[1:i])      
  }
  p<-matrix(p,ncol=1)
  colnames(p)<-paste("p.value")
  bh<-matrix(bh,ncol=1)
  colnames(bh)<-paste("BH  ")
  test1<-matrix(test1,ncol=1)
  colnames(test1)<-paste("BH-result")
  abh<-matrix(abh,ncol=1)
  colnames(abh)<-paste("ABH  ")
  test2<-matrix(test2,ncol=1)
  colnames(test2)<-paste("ABH-result")
  result<-cbind(p,bh,test1,abh,test2)
  if(i==0){
    list(result=result,Significant_number =NULL ,q = q)
  }else{
    list(result=result,Significant_number =J ,q = q)
  }
#>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>
#  >>>input<<<
#       x: vector data (p-values)
#
#  >>>output<<<
#       result
#         p.value                 : p-values (the ordered p-values)  
#         FDR value (BH and ABH)  : e.x. (0.005,EEE,0.05)
#         test (BH and ABH)       : test result (by the ordered x)
#                                   (1: significant)
#                                   (0: not significant)
#       Significant               : test result
#                                   (rejected input data's hypotheses number)
#       q                         : e.x. (0.05)
#              
#>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<
#
#                                                         01/17/06  by  Horiuchi
}
