Tucker <- function(x, y, M = 0, N = 0)
{
#>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#>>>>                                                   <<<<<
#>>>>   Tucker model analysis (twice factor analized)   <<<<<
#>>>>                                                   <<<<<
#>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	pw <- prcomp(scale(x))
	s <- pw$sdev
	S <- s * s
	if(M == 0) {
		for(i in 1:length(s)) {
			if(s[[i]] >= 1)
				M <- M + 1
		}
	}
	fw <- factanal(x, factors = M, scores="regression")
	fwl <- fw$loadings
	sw <- fw$scores
	ws <- t(sw)
	h <- ncol(ws)/y
	gw <- NULL
	for(j in 1:y) {
		gw <- rbind(gw, (cbind(ws[, ((1 + h * j) - h):(h * (j + 1) - h)
			])))
	}
	gpw <- prcomp(scale(gw))
	r <- gpw$sdev
	R <- r * r
	if(N == 0) {
		for(k in 1:length(r)) {
			if(r[[k]] >= 1)
				N <- N + 1
		}
	}
	gfw <- factanal(gw, factors = N, scores="regression")
	gfwl <- gfw$loadings
	gfws <- gfw$scores
	uniI <- fw$uniquenesses
	uniII <- gfw$uniquenesses
	l1 <- NULL
	for(k in 1:M) {
		for(k2 in 1:N) {
			n1 <- paste("Factor", k, ":", k2, sep = "")
			l1 <- c(l1, n1)
		}
	}
	cldata <- NULL
	for(j in 1:y) {
		cld1 <- NULL
		for(k in 1:M) {
			cld1 <- c(cld1, gfws[(j - 1) * M + k,  ])
		}
		cld1 <- matrix(cld1, nrow = 1)
		dimnames(cld1) <- list(NULL, l1)
		cldata <- rbind(cldata, cld1)
	}
	ans <- list(KoyuchiI = S, FactorsI = M, Firstloadings = fwl, KoyuchiII
		 = R, FactorsII = N, Secondloadings = gfwl, Secondscores = gfws,
		UniquenessesI = uniI, UniquenessesII = uniII, Clusterdata = 
		cldata)
	ans	#
#<<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>>
#
#  >>> input <<<
#              x: data matrix ((person x object)x adjective)
#              y: nember of persons
#              M: nember of factors for adjectives
#                 (default: the number of eigen values which are larger than
#                           or equal to 1)
#              N: nember of factors for objects
#                 (default: the number of eigen values which are larger than
#                           or equal to 1)
#
#  >>> output <<<
#       KoyuchiI: eigen values of adjectives 
#       FactorsI: nember of factors for adjectives
#  Firstloadings: factor loadings matrix for adjectives
#      KoyuchiII: eigen values of objects 
#      FactorsII: nember of factors for objects
# Secondloadings: factor loadings matrix for objects
#   Secondscores: scores for each person
#  UniquenessesI: uniquenesses of adjectives
# UniquenessesII: uniquenesses of objects
#    Clusterdata: scores for the use of cluster analysis
#
#<<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>>
#                                                03/20/01  by  Okumura
#                                     R version  09/16/04  by  matsu
}
