hayashi1 <- function(x, y)
{
#>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#>>>>                                             <<<<<
#>>>>   Quantification theory type I (hayashi1)   <<<<<
#>>>>                                             <<<<<
#>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        for(i in 1:ncol(x)) {
                if(i == 1) {
                        i.c.sum <- tapply(y, x[, i], sum)
                        index <- rep(i, length(table(x[, i])))
                }
                else {
                        i.c.sum <- c(i.c.sum, tapply(y, x[, i], sum))
                        index <- c(index, rep(i, length(table(x[, i]))))
                }
        }
        item <- table(index)
        x.cross <- cbind(cross(x)$x, i.c.sum)
        labels <- cross(x)$label
        dimnames(x.cross) <- list(labels, c(labels, "i.c.sum"))
        item.cut.r <- cumsum(item)[2:length(item)]
        item.cut.c <- c(item.cut.r, ncol(x.cross))
        kekka.solve <- solve(x.cross[ - item.cut.r,  - item.cut.c]) %*% x.cross[ - 
                item.cut.r, ncol(x.cross)]
        kekka <- matrix(0, nrow = nrow(x.cross), ncol = 1)
        point <- 1
        for(i in 1:nrow(x.cross)) {
                st <- 0
                for(j in 1:length(item.cut.r)) {
                        if(item.cut.r[j] == i)
                                st <- 1
                }
                if(st == 0) {
                        kekka[i, 1] <- kekka.solve[point]
                        point <- point + 1
                }
        }
        kekka.sum <- tapply(kekka * diag(x.cross), index, sum)/nrow(x)
        kekka <- cbind(kekka, kekka.sum[index])
        kekka.item <- matrix(nrow = max(item), ncol = length(item))
        kekka.range <- matrix(nrow = nrow(kekka), ncol = 1)
        for(i in 1:length(item))
                for(j in 1:item[i]) {
                        if(i == 1 && j == 1)
                                k <- 1
                        kekka.item[j, i] <- kekka[k, 1] - kekka[k, 2]
                        kekka.range[k, 1] <- kekka[k, 1] - kekka[k, 2]
                        k <- k + 1
                }
        if (is.null(names(x))) {
                item.label <- paste("item", 1:length(item))
        } else {
                item.label <- names(x)
        }
        category.label <- paste("category", 1:max(item))
        dimnames(kekka.item) <- list(category.label, item.label)
        kekka.range <- tapply(kekka.range, index, max) - tapply(kekka.range, 
                index, min)
        kekka.range <- matrix(kekka.range, ncol = 1)
        dimnames(kekka.range) <- list(item.label, "")
        obser.item <- matrix(0, nrow = nrow(x), ncol = length(item))
        for(i in 1:nrow(x)) {
                for(j in 1:length(item)) {
                        tx <- table(x[,j])
                        l <- 1
                        while (x[i,j]!=names(tx)[l]) l <- l+1
                        obser.item[i, j] <- kekka.item[l, j]
                }
        }
        R <- cor(cbind(y, obser.item))
        R.1 <- solve(R)
        r <- sqrt(1 - 1/R.1[1, 1])
        hen.cor <- matrix(nrow = length(item), ncol = 1)
        for(i in 1:length(item))
                hen.cor[i] <-  - R.1[1, (1 + i)]/sqrt(R.1[1, 1] * R.1[(1 + i), (
                        1 + i)])
        dimnames(hen.cor) <- list(item.label, "")
        y.hat <- apply(obser.item, 1, sum) + mean(y)
        z <- as.vector(scale(y - y.hat))
        list(cross = x.cross, score = kekka.item, range = kekka.range, 
                partial.cor = hen.cor, R.2 = round(r^2, 5), y.mean = mean(y), 
                y.hat = y.hat, z = round(z, 5)) #
#<<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>>
#
#  >>> input <<<
#           x: item.category_data matrix.
#           y: response variable.
#
#  >>> output <<<
#       cross: cross table
#       score: item score
#       range: item range
# partial.cor: partial correlation coefficient
#         R.2: coefficient of determination
#      y.mean: constant term
#       y.hat: prediction value
#           z: standardized residuals(=scale(y-y.hat))
#
#<<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>>
#                                                     01/28/97  by anne
#                                 modified for R      10/29/02 by matsu
#                                       modified      11/04/04 by matsu
}

hayashi2 <- function(x, y, label = NULL)
{
#>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#>>>>                                              <<<<<
#>>>>   Quantification theory type II (hayashi2)   <<<<<
#>>>>                                              <<<<<
#>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        cross.out <- cross(x, Label = label)
        x.cross <- cross.out$x
        labels <- cross.out$label
        nr <- nrow(x.cross)
        hyo.t <- matrix(nrow = nr, ncol = nr)
        for(i in 1:nr)
                for(j in 1:nr)
                        hyo.t[i, j] <- x.cross[i, j] - (x.cross[i, i] * x.cross[
                                j, j])/length(y)
        response <- table(y)
        hyo.b <- matrix(nrow = nr, ncol = nr)   
        #xy.cross <-cross(cbind(y,x))[1:length(response),]
        for(i in 1:(ncol(x) + 1)) {
                if(i == 1)
                        xy.cross <- table(y, y)
                else xy.cross <- cbind(xy.cross, table(y, x[, i - 1]))
        }
        for(i in 1:nr)
                for(j in 1:nr)
                        hyo.b[i, j] <- sum((xy.cross[, (length(response) + i)] * 
                                xy.cross[, (length(response) + j)])/response) - (
                                x.cross[i, i] * x.cross[j, j])/length(y)
        for(i in 1:ncol(x)) {
                if(i == 1)
                        item <- length(table(x[, i]))
                else item <- c(item, length(table(x[, i])))
        }
        item.cut <- c(1, cumsum(item) + 1)[ - (length(item) + 1)]
        t.ast <- hyo.t[ - item.cut,  - item.cut]
        b.ast <- hyo.b[ - item.cut,  - item.cut]        
        # t.ast -> Q lambda Q':  QQ' = Q'Q = I, lambda = eigen values
#
        t.eigen.values <- round(eigen(t.ast)$values, 10)
        t.eigen.vectors <- eigen(t.ast)$vectors 
        # t.ast = PP': P = Q lambda^{1/2}
        P <- t.eigen.vectors %*% sqrt(diag(t.eigen.values))     
        #P <- t(chol(t.ast))
        values.ast <- eigen(solve(P) %*% b.ast %*% solve(t(P)))$values  
        #values.ast2 <- as.numeric(values.ast)
#if(is.complex(values.ast)){
#       print(" Wainig messages ")
#}
        values.ast <- round(values.ast, 5)
        vectors.ast <- round(solve(t(P)) %*% eigen(solve(P) %*% b.ast %*% solve(
                t(P)))$vectors, 5)
        if(is.complex(values.ast))
                mode(values.ast) <- "numeric"
        if(is.complex(vectors.ast))
                mode(vectors.ast) <- "numeric"
        vectors.ast <- vectors.ast[, (values.ast > 0)]
        values.ast <- values.ast[values.ast > 0]        ##########
## vectors <- weighted
        if(!is.matrix(vectors.ast))
                vectors.ast <- matrix(vectors.ast, nrow = length(vectors.ast), 
                        ncol = 1)
        for(i in 1:ncol(vectors.ast)) {
                k.coef <- c(if(i != 1) {
                        k.coef
                }
                , sqrt(length(y)/vectors.ast[, i] %*% t.ast %*% vectors.ast[, i
                        ]))
                vectors.new <- cbind(if(i != 1) {
                        vectors.new
                }
                ,  - k.coef[i] * vectors.ast[, i])
        }
###### score
## category no frame
        category.dat <- matrix(0, nrow = nr, ncol = ncol(vectors.new))
        input <- c(1:nr)[ - item.cut]
        for(i in 1:ncol(vectors.new)) {
                for(j in 1:nrow(vectors.new)) {
                        category.dat[input[j], i] <- vectors.new[j, i]
                }
        }
## standarded
        prod.ca <- diag(x.cross) * category.dat
        for(i in 1:length(item))
                index <- c(if(i != 1) {
                        index
                }
                , rep(i, item[i]))      ## result
        for(i in 1:ncol(prod.ca))
                for(j in 1:nr)
                        category.dat[j, i] <- category.dat[j, i] - (tapply(
                                prod.ca[, i], index, sum)/nrow(x))[index[j]]
        dims <- paste("dim", c(1:ncol(category.dat)))
        dimnames(category.dat) <- list(labels, dims)
        f.e <- cbind(c(1, (cumsum(item) + 1)[ - length(item)]), cumsum(item))
        for(i in 1:ncol(category.dat)) {
                for(j in 1:length(item)) {
                        cat.range <- c(if(j != 1) {
                                cat.range
                        }
                        , dist(range(category.dat[f.e[j, 1]:f.e[j, 2], i])))
                }
                category.range <- cbind(if(i != 1) {
                        category.range
                }
                , cat.range)
        }
      if (is.null(names(x)))
             dimnames(category.range) <- list(c("item 1", 2:length(item)), dims)        
      else
             dimnames(category.range) <- list(names(x), dims)
        ## n-jigen-score
        for(k in 1:ncol(category.dat)) {
                score.ob <- matrix(0, nrow = length(y), ncol = length(item))
                for(i in 1:nrow(score.ob)) {
                        for(j in 1:length(item)) {
                        tx <- table(x[,j])
                        l <- 1
                        while (x[i,j]!=names(tx)[l]) l <- l+1
                                if(j == 1)
                                  score.ob[i, j] <- category.dat[l, k]
                                else score.ob[i, j] <- category.dat[l + 
                                    cumsum(item)[j - 1], k]
                        }
                }
                sample.score <- cbind(if(k != 1) {
                        sample.score
                }
                , apply(score.ob, 1, sum))
                observ <- cbind(if(k != 1) {
                        observ
                }
                , score.ob)
        }
        dimnames(sample.score) <- list(c(1:length(y)), dims)
        for(i in 1:ncol(category.dat)) {
                gaiteki <- cbind(if(i != 1) {
                        gaiteki
                }
                , tapply(sample.score[, i], y, sum)/table(y))
        }
      yt <- table(y)
      dimnames(gaiteki) <- list(names(yt), dims)
        gai.res <- matrix(0, nrow = length(y), ncol = ncol(gaiteki))
        for(i in 1:ncol(gaiteki))
                for(j in 1:length(y)) {
                  k <- 1
                        while (y[j]!=names(yt)[k]) k <- k+1
                  gai.res[j, i] <- gaiteki[k, i]
            }
        hen.cor <- matrix(nrow = length(item), ncol = ncol(gaiteki))
        for(i in 1:ncol(gaiteki)) {
                first <- (i - 1) * ncol(x) + 1
                end <- first + ncol(x) - 1
                R <- cor(cbind(gai.res[, i], observ[, first:end]))
                R.1 <- solve(R)
                r <- c(if(i != 1) {
                        r
                }
                , sqrt(1 - 1/R.1[1, 1]))
                for(j in 1:length(item))
                        hen.cor[j, i] <-  - R.1[1, (1 + j)]/sqrt(R.1[1, 1] * 
                                R.1[(1 + j), (1 + j)])
        }
        R.2 <- r^2      #( = eigen.values )
      if (is.null(names(x)))
             dimnames(hen.cor) <- list(c("item 1", 2:length(item)), dims)
      else
             dimnames(hen.cor) <- list(names(x), dims)
        list(cross = x.cross,   #hyo.t=hyo.t,hyo.b=hyo.b, 
        eigen.values = values.ast, score = category.dat, gaiteki = gaiteki, 
                partial.cor = hen.cor, range = category.range, sample.score = 
                sample.score)   #
#<<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>>
#
#  >>> input <<<
#            x: item.category_data matrix.
#            y: response variable.
#        label: labels of item. (default:NULL is auto-labeling)
#
#  >>> output <<<
#        cross: cross table
# eigen.values: eigen values (correlation ratio)
#        score: item score
#      gaiteki: scores for response variable
#  partial.cor: partial correlation coefficient
#        range: item range
# sample.score: scores for sample
#
#<<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>>
#                                                    02/03/97  by anne
#                                         modified   11/04/04  by matsu
#
}

hayashi3 <- function(x, wt = F)
{
#>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#>>>>                                               <<<<<
#>>>>   Quantification theory type III (hayashi3)   <<<<<
#>>>>                                               <<<<<
#>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        n <- ncol(x)
        d1 <- apply(x, 1, sum)
        d2 <- apply(x, 2, sum)
        d3 <- ifelse(d1 == 0, 0, 1/d1)
        d4 <- ifelse(d2 == 0, 0, 1/sqrt(d2))
        d3 <- diag(d3, nrow = length(d3))
        d4 <- diag(d4, nrow = length(d4))
        m1 <- t(x)
        y <- round(d4 %*% m1 %*% d3 %*% as.matrix(x) %*% d4, 5)
        evalue <- eigen(y)$values
        evector <- eigen(y)$vectors
        evector <- evector * sqrt(sum(x))
        b <- d4 %*% evector
        evalue2 <- 1/sqrt(evalue)
        evalue2 <- diag(evalue2, ncol = length(evalue2))
        if(!wt)
                a <- d3 %*% as.matrix(x) %*% b
        else a <- d3 %*% x %*% b %*% evalue2
        row.names(a)<-row.names(x)
        row.names(b)<-names(x)
        list(data = x, evalue = round(evalue, 4), row = round(a, 4), col = 
                round(b, 4)) #
#<<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>>
#
#  >>> input <<<
#           x: item.category_data matrix.
#          wt: flag of using the weight(evalue2). default is F
#
#  >>> output <<<
#        data: item.category_data matrix
#      evalue: eigen values
#         row: scores for sample (the first column is omited)
#         col: scores for item (the first column is omited)
#
#<<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>>
#                                                     02/??/97  by anne
#                                      modified       09/11/06 by matsu
}

hayashi4 <- function(x, e = T)
{
#>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#>>>>                                              <<<<<
#>>>>   Quantification theory type IV (hayashi4)   <<<<<
#>>>>                                              <<<<<
#>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        y <- x
        if(!e) {
                nr <- nrow(x)
                nc <- ncol(x)
                e <- matrix(nrow = nc, ncol = nc)
                x[x == 0] <- -1
                for(i in 1:nc)
                        for(j in 1:nc)
                                e[i, j] <- sum(abs(x[, i] + x[, j]))/2
                shinkin <- e
        }
        else {
                shinkin <- x
        }
       h <- shinkin+t(shinkin)
        h[row(h) == col(h)] <- 0
        d1 <- apply(h, 1, "sum")
        h <- h - diag(d1, nrow = length(d1))
       diag(h) <- -d1
        evalue <- round(eigen(h)$values, 4)
        evector <- round(eigen(h)$vectors, 4)
       rownames(shinkin) <- colnames(shinkin) <- names(x)
       rownames(h) <- colnames(h) <- names(x)
       rownames(evector) <- names(x)
        list(data = y, eij = shinkin, H = h, evalue = evalue, evector = evector
                ) #
#<<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>>
#
#  >>> input <<<
#           x: similarity matrix or data matrix.
#           e: flag of data type. (default: T)
#              if (e==T) then x is similarity matrix
#              else x is data matrix.
#
#  >>> output <<<
#        data: original matrix of x
#         eij: similarity matrix
#           H: H matrix
#      evalue: eigen values (the first value (0) is omited)
#     evector: eigen vector (the first column is omited)
#
#<<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>><<<<<>>>>>
#                                                     02/??/97  by anne
#                                                     11/21/02 by matsu
#                                       modified      09/08/06 by matsu
}

cross <- function(x, Label = NULL, Out = T)
{
# Using from hayashi1, hayashi2
#                                01/28/97 by anne
#                      modified  11/04/04 by matsu
        for(i in 1:ncol(x)) {
                tt <- table(x[, i])
                taikaku <- c(if(i != 1) {
                        taikaku
                }
                , tt)
                def.label <- c(if(i != 1) {
                        def.label
                }
                , paste(if(is.null(names(x))) {
                          i
                          } else {
                          names(x)[i]
                }
                , "-", names(tt)))
                item.num <- c(if(i != 1) {
                        item.num
                }
                , length(tt))
        }
        x.cross <- diag(taikaku)
        item.last <- cumsum(item.num)
        item.first <- item.last - item.num + 1
        for(i in 1:(length(item.num) - 1))
                for(j in i:length(item.num)) {
                        if(i != j)
                                x.cross[item.first[i]:item.last[i], item.first[
                                  j]:item.last[j]] <- table(x[, i], x[, j])
                }
        x.cross <- t(x.cross) + x.cross - diag(taikaku)
        if(is.null(Label))
                dimnames(x.cross) <- list(def.label, def.label)
        else {
                dimnames(x.cross) <- list(Label, Label)
                def.label <- Label
        }
        list(x = x.cross, label = def.label)
}
